Index: loader/source/main.c
===================================================================
--- loader/source/main.c	(revision 542)
+++ loader/source/main.c	(working copy)
@@ -26,6 +26,7 @@
 #include <di/di.h>
 
 #include <unistd.h>
+#include <sys/stat.h>
 
 #include "exi.h"
 #include "dip.h"
@@ -67,8 +68,9 @@
 #define HW_DIFLAGS		0xD800180
 #define MEM_PROT		0xD8B420A
 
-#define IOCTL_ExecSuspendScheduler	1
-
+#define IOCTL_ExecSuspendScheduler 1
+ 	
+int intro = 0;
 static GXRModeObj *vmode = NULL;
 
 static const unsigned char Boot2Patch[] =
@@ -113,6 +115,8 @@
 
 extern vu32 FoundVersion;
 vu32 KernelLoaded = 0;
+int hid_count=0;
+int ExitBoot=0;
 u32 entrypoint = 0;
 char launch_dir[MAXPATHLEN] = {0};
 extern void __exception_closeall();
@@ -199,49 +203,48 @@
 {
 	f_chdrive(primaryDevice);
 	f_chdir_char("/");
+	f_mkdir_char("/apps");
+	f_mkdir_char("/apps/Nintendont");
 }
 
 int main(int argc, char **argv)
 {
-	// Exit after 10 seconds if there is an error
+// Exit after 10 seconds if there is an error
 	__exception_setreload(10);
 //	u64 timeout = 0;
 	CheckForGecko();
 	DCInvalidateRange(loader_stub, 0x1800);
 	memcpy(loader_stub, (void*)0x80001800, 0x1800);
-
 	RAMInit();
-
-	//Meh, doesnt do anything anymore anyways
-	//STM_RegisterEventHandler(HandleSTMEvent);
-
+	
+ 	//Meh, doesnt do anything anymore anyways
+	//STM_RegisterEventHandler(HandleSTMEvent);	
+	
 	Initialise();
-
 	// Initializing IOS58...
 	ShowMessageScreen("Initializing IOS58...");
-
-	u32 u;
-	//Disables MEMPROT for patches
+	
+ 	u32 u;
+ 	//Disables MEMPROT for patches
 	write16(MEM_PROT, 0);
 	//Patches FS access
 	for( u = 0x93A00000; u < 0x94000000; u+=2 )
 	{
-		if( memcmp( (void*)(u), FSAccessPattern, sizeof(FSAccessPattern) ) == 0 )
+	if( memcmp( (void*)(u), FSAccessPattern, sizeof(FSAccessPattern) ) == 0 )
 		{
-		//	gprintf("FSAccessPatch:%08X\r\n", u );
-			memcpy( (void*)u, FSAccessPatch, sizeof(FSAccessPatch) );
-			DCFlushRange((void*)u, sizeof(FSAccessPatch));
-			break;
-		}
+	// gprintf("FSAccessPatch:%08X\r\n", u );
+	memcpy( (void*)u, FSAccessPatch, sizeof(FSAccessPatch) );
+	DCFlushRange((void*)u, sizeof(FSAccessPatch));
+	break;
+		}		
 	}
-
-	//for BT.c
+ 	//for BT.c
 	CONF_GetPadDevices((conf_pads*)0x932C0000);
 	DCFlushRange((void*)0x932C0000, sizeof(conf_pads));
 	*(vu32*)0x932C0490 = CONF_GetIRSensitivity();
 	*(vu32*)0x932C0494 = CONF_GetSensorBarPosition();
 	DCFlushRange((void*)0x932C0490, 8);
-
+	
 	// Load and patch IOS58.
 	if (LoadKernel() < 0)
 	{
@@ -258,49 +261,47 @@
 		// Return to the loader.
 		ExitToLoader(1);
 	}
-
-	void *kernel_bin = NULL;
+	
+ 	void *kernel_bin = NULL;
 	u32 kernel_bin_size = 0;
 	unzip_data(kernel_zip, kernel_zip_size, &kernel_bin, &kernel_bin_size);
 	gprintf("Decompressed kernel.bin with %i bytes\r\n", kernel_bin_size);
 	InsertModule((char*)kernel_bin, kernel_bin_size);
 	free(kernel_bin);
-
+	
 	memset( (void*)0x92f00000, 0, 0x100000 );
 	DCFlushRange( (void*)0x92f00000, 0x100000 );
-
+	
 	DCInvalidateRange( (void*)0x939F02F0, 0x20 );
-
+	
 	memcpy( (void*)0x939F02F0, Boot2Patch, sizeof(Boot2Patch) );
-
+	
 	DCFlushRange( (void*)0x939F02F0, 0x20 );
-
-	//libogc still has that, lets close it
-	__ES_Close();
+ 	//libogc still has that, lets close it
+	__ES_Close();	
 	s32 fd = IOS_Open( "/dev/es", 0 );
-
-	memset( STATUS, 0xFFFFFFFF, 0x20  );
+	
+	memset( STATUS, 0xFFFFFFFF, 0x20 );
 	DCFlushRange( STATUS, 0x20 );
-
-	memset( (void*)0x91000000, 0xFFFFFFFF, 0x20  );
+	
+	memset( (void*)0x91000000, 0xFFFFFFFF, 0x20 );
 	DCFlushRange( (void*)0x91000000, 0x20 );
-
+	
 	*(vu32*)0xD3003420 = 0; //make sure kernel doesnt reload
-
+	
 	raw_irq_handler_t irq_handler = BeforeIOSReload();
 	IOS_IoctlvAsync( fd, 0x1F, 0, 0, &IOCTL_Buf, NULL, NULL );
 	AfterIOSReload( irq_handler, FoundVersion );
+        while(1)
+        {
+                DCInvalidateRange( STATUS, 0x20 );
+                if((STATUS_LOADING > 0 || abs(STATUS_LOADING) > 1) && STATUS_LOADING < 20)
+                {
+                        gprintf("Kernel sent signal\n");
+                        break;
+                }
+        }
 
-	while(1)
-	{
-		DCInvalidateRange( STATUS, 0x20 );
-		if((STATUS_LOADING > 0 || abs(STATUS_LOADING) > 1) && STATUS_LOADING < 20)
-		{
-			gprintf("Kernel sent signal\n");
-			break;
-		}
-	}
-
 	// Checking for storage devices...
 	ShowMessageScreen("Checking storage devices...");
 
@@ -331,18 +332,18 @@
 		ExitToLoader(1);
 	}
 
-	gprintf("Nintendont at your service!\r\n%s\r\n", NIN_BUILD_STRING);
-	KernelLoaded = 1;
+ 	gprintf("Nintendont at your service!\r\n%s\r\n", NIN_BUILD_STRING);
+ 	KernelLoaded = 1;
 
 	char* first_slash = strrchr(argv[0], '/');
 	if (first_slash != NULL) strncpy(launch_dir, argv[0], first_slash-argv[0]+1);
 	gprintf("launch_dir = %s\r\n", launch_dir);
-
 	// Initialize controllers.
 	// FIXME: Initialize before storage devices.
 	// Doing that right now causes usbstorage to fail...
 	FPAD_Init();
-	FPAD_Update();
+	FPAD_Update();	
+	f_chdir_char("/apps/Nintendont");
 
 	/* Read IPL Font before doing any patches */
 	void *fontbuffer = memalign(32, 0x50000);
@@ -351,18 +352,19 @@
 	DCInvalidateRange( (void*)0x93100000, 0x50000 );
 	free(fontbuffer);
 	//gprintf("Font: 0x1AFF00 starts with %.4s, 0x1FCF00 with %.4s\n", (char*)0x93100000, (char*)0x93100000 + 0x4D000);
-
+	
 	// Update meta.xml.
 	updateMetaXml();
 
 	// Load titles.txt.
 	LoadTitles();
+	memset((void*)ncfg, 0, sizeof(NIN_CFG));
+	 
 
-	memset((void*)ncfg, 0, sizeof(NIN_CFG));
 	bool argsboot = false;
 	if(argc > 1) //every 0x00 gets counted as one arg so just make sure its more than the path and copy
-	{
-		memcpy(ncfg, argv[1], sizeof(NIN_CFG));
+	{	
+		memcpy(ncfg, argv[1], sizeof(NIN_CFG));	
 		UpdateNinCFG(); //support for old versions with this
 		if(ncfg->Magicbytes == 0x01070CF6 && ncfg->Version == NIN_CFG_VERSION && ncfg->MaxPads <= NIN_CFG_MAXPAD)
 		{
@@ -372,9 +374,62 @@
 				argsboot = true;
 			}
 		}
+		GRRLIB_FreeTexture(background);
+		CheckTheme();
+		FadeIt();
+		// Prevent autobooting if B is pressed
+		int i = 0;
+		while((ncfg->Config & NIN_CFG_AUTO_BOOT) && (i < 500000)) // wait for wiimote re-sync
+		{	
+			if (i == 0) {
+				PrintInfo();
+        if (which_bg == BG_NONE)
+        {
+           PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 320 - 90, MENU_POS_Y + 20*10, "B: Cancel Autoboot");
+           GRRLIB_Render();
+           ClearScreen();
+        }
+        else if (which_bg == BG_LEGACY)
+        {
+           PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 320 - 90, MENU_POS_Y + 20*10, "B: Cancel Autoboot");
+           GRRLIB_Render();
+           ClearScreen();
+        }
+        else if (which_bg == BG_BLACK)
+        {
+           GRRLIB_Render();
+           ClearScreen();
+        }
+        else
+        {
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 406, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 406, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 406, "B: Cancel Autoboot"); 
+        PrintFormat(DEFAULT_SIZE, WHITE, 230, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		GRRLIB_Render();
+		ClearScreen();
+        }
+		}
+		FPAD_Update();
+			if (FPAD_Cancel(0)) {
+				ncfg->Config &= ~NIN_CFG_AUTO_BOOT;
+				ExitBoot=1;
+				FadeOut();
+				BackTheme();
+				break;
+			}
+			i++;
+		}
 	}
+
 	if(argsboot == false)
-	{
+	{			
+		//UpdateNinCFG(); //support for old versions with this
 		if (LoadNinCFG() == false)
 		{
 			memset(ncfg, 0, sizeof(NIN_CFG));
@@ -385,31 +440,64 @@
 			ncfg->MaxPads = NIN_CFG_MAXPAD;
 			ncfg->MemCardBlocks = 0x2;//251 blocks
 		}
-
+		// Use Custom Width 0 scale gives 600 width 120 scale gives 720
+		//ncfg->VideoScale = 120;
+		//
 		// Prevent autobooting if B is pressed
+			GRRLIB_FreeTexture(background);
+			CheckTheme();
+			FadeIt();
 		int i = 0;
-		while((ncfg->Config & NIN_CFG_AUTO_BOOT) && i < 1000000) // wait for wiimote re-synch
-		{
+		while((ncfg->Config & NIN_CFG_AUTO_BOOT) && (i < 500000)) // wait for wiimote re-sync
+		{	
 			if (i == 0) {
-				PrintInfo();
-				PrintFormat(DEFAULT_SIZE, BLACK, 320 - 90, MENU_POS_Y + 20*10, "B: Cancel Autoboot");
-				GRRLIB_Render();
-				ClearScreen();
-			}
-			
+				PrintInfo();		
+        if (which_bg == BG_NONE)
+        {
+            PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 320 - 90, MENU_POS_Y + 20*10, "B: Cancel Autoboot");
+            GRRLIB_Render();
+			ClearScreen();
+        }
+        else if (which_bg == BG_LEGACY)
+        {
+           PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 320 - 90, MENU_POS_Y + 20*10, "B: Cancel Autoboot");
+           GRRLIB_Render();
+           ClearScreen();
+        }
+        else if (which_bg == BG_BLACK)
+        {
+           GRRLIB_Render();
+           ClearScreen();
+        }
+        else
+        {
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 406, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 406, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 410, "B: Cancel Autoboot");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 406, "B: Cancel Autoboot"); 
+        PrintFormat(DEFAULT_SIZE, WHITE, 230, MENU_POS_Y + 408, "B: Cancel Autoboot");
+		GRRLIB_Render();
+		ClearScreen();
+        }
+		}
 			FPAD_Update();
-
 			if (FPAD_Cancel(0)) {
-				ncfg->Config &= ~NIN_CFG_AUTO_BOOT;
+			ncfg->Config &= ~NIN_CFG_AUTO_BOOT;
+			ExitBoot=1;
+			FadeOut();
+			BackTheme();
 				break;
 			}
-
 			i++;
 		}
 	}
+
 	ReconfigVideo(rmode);
 	UseSD = (ncfg->Config & NIN_CFG_USB) == 0;
-
 	bool progressive = (CONF_GetProgressiveScan() > 0) && VIDEO_HaveComponentCable();
 	if(progressive) //important to prevent blackscreens
 		ncfg->VideoMode |= NIN_VID_PROG;
@@ -418,10 +506,11 @@
 
 	bool SaveSettings = false;
 	if(!(ncfg->Config & NIN_CFG_AUTO_BOOT))
-	{
-		// Not autobooting.
-		// Prompt the user to select a device and game.
-		SaveSettings = SelectDevAndGame();
+	{	
+		BackTheme();
+		GRRLIB_Render();
+		//FadeIt();
+		SaveSettings = SelectGameList(); //SelectDevAndGame();
 	}
 	else
 	{
@@ -436,7 +525,29 @@
 	u32 CurDICMD = 0;
 	if( memcmp(ncfg->GamePath, "di", 3) == 0 )
 	{
-		ShowLoadingScreen();
+		ClearScreen();
+		if (which_bg == BG_NONE)
+		{
+		PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Loading, please wait...");
+		}
+		else if (which_bg == BG_LEGACY)
+		{
+		PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Loading, please wait...");
+		}
+		else
+		{
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 408, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 408, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, WHITE, 230, MENU_POS_Y + 408, "Loading, please wait...");		
+		}
+		GRRLIB_Render();
+		ClearScreen();
 
 		DI_UseCache(false);
 		DI_Init();
@@ -445,10 +556,12 @@
 			usleep(20000);
 		if(!(DI_GetStatus() & DVD_READY))
 		{
-			ShowMessageScreenAndExit("The Disc Drive could not be initialized!", 1);
+			ClearScreen();
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, 232, "The Disc Drive could not be initialized!" );
+			ExitToLoader(1);
 		}
 		DI_Close();
-
+		
 		u8 *DIBuf = memalign(32,0x800);
 		memset(DIBuf, 0, 0x20);
 		DCFlushRange(DIBuf, 0x20);
@@ -463,7 +576,9 @@
 			if( IsGCGame(DIBuf) == false )
 			{
 				free(DIBuf);
-				ShowMessageScreenAndExit("The Disc in the Drive is not a GC Disc!", 1);
+				ClearScreen();
+				PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, 232, "The Disc in the Drive is not a GC Disc!" );
+				ExitToLoader(1);
 			}
 		}
 		memcpy(&(ncfg->GameID), DIBuf, 4);
@@ -487,7 +602,7 @@
 		// Write config to the game device, used by the Nintendont kernel.
 		char ConfigPath[20];
 		snprintf(ConfigPath, sizeof(ConfigPath), "%s:/nincfg.bin", GetRootDevice());
-		if (f_open_char(&cfg, ConfigPath, FA_WRITE|FA_OPEN_ALWAYS) == FR_OK)
+		if (f_open_char(&cfg, ConfigPath, FA_WRITE|FA_OPEN_ALWAYS) == FR_OK)		
 		{
 			UINT wrote;
 			f_write(&cfg, ncfg, sizeof(NIN_CFG), &wrote);
@@ -494,12 +609,14 @@
 			f_close(&cfg);
 		}
 	}
-
 	// Check for multi-game disc images.
 	u32 ISOShift = 0;
 	if(memcmp(&(ncfg->GameID), "COBR", 4) == 0 || memcmp(&(ncfg->GameID), "GGCO", 4) == 0
-		|| memcmp(&(ncfg->GameID), "GCO", 3) == 0 || memcmp(&(ncfg->GameID), "RGCO", 4) == 0)
-	{
+	|| memcmp(&(ncfg->GameID), "GCO", 3) == 0 || memcmp(&(ncfg->GameID), "RGCO", 4) == 0)
+		{
+		which_bg = BG_NONE;
+		BackTheme();
+
 		u32 i, j = 0;
 		u32 Offsets[15];
 		gameinfo gi[15];
@@ -508,7 +625,7 @@
 		FIL f;
 		UINT read;
 		FRESULT fres = FR_DISK_ERR;
-
+		
 		if(CurDICMD)
 		{
 			ReadRealDisc(MultiHdr, 0, 0x800, CurDICMD);
@@ -521,8 +638,7 @@
 			if (fres == FR_OK)
 				f_read(&f, MultiHdr, 0x800, &read);
 		}
-
-		//Damn you COD for sharing this ID!
+//Damn you COD for sharing this ID!
 		if (fres != FR_OK || (memcmp(MultiHdr, "GCO", 3) == 0 && memcmp(MultiHdr+4, "52", 3) == 0))
 		{
 			free(MultiHdr);
@@ -558,9 +674,7 @@
 				}
 			}
 			free(GameHdr);
-			free(MultiHdr);
 			f_close(&f);
-
 			bool redraw = 1;
 			ClearScreen();
 			u32 PosX = 0;
@@ -596,21 +710,27 @@
 				else
 					UpHeld = 0;
 				if( redraw )
-				{
-					PrintInfo();
-					for( i=0; i < j; ++i )
-						PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*4 + i * 20, "%50.50s [%.6s]%s", 
-							gi[i].Name, gi[i].ID, i == PosX ? ARROW_LEFT : " " );
-					GRRLIB_Render();
-					Screenshot();
-					ClearScreen();
-					redraw = false;
-				}
+			{
+				PrintInfo();
+				for( i=0; i < j; ++i )
+		if (which_bg == BG_NONE)
+		{
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*5 + i * 20, "%50.50s [%.6s]%s", gi[i].Name, gi[i].ID, i == PosX ? ARROW_LEFT : " " );
+		}
+		else if (which_bg == BG_LEGACY)
+		{
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*5 + i * 20, "%50.50s [%.6s]%s", gi[i].Name, gi[i].ID, i == PosX ? ARROW_LEFT : " " );
+		}
+				GRRLIB_Render();
+				Screenshot();
+				ClearScreen();
+				redraw = false;
 			}
-			ISOShift = Offsets[PosX];
-			memcpy(&(ncfg->GameID), gi[PosX].ID, 4);
 		}
+		ISOShift = Offsets[PosX];
+		memcpy(&(ncfg->GameID), gi[PosX].ID, 4);
 	}
+	}
 //multi-iso game hack
 	*(vu32*)0xD300300C = ISOShift;
 
@@ -640,17 +760,20 @@
 		}
 	}
 
+	u32 IsTRIGame = 0;
+	if (ncfg->GameID != 0x47545050) //Damn you Knights Of The Temple!
+	IsTRIGame = TRISetupGames(ncfg->GamePath, CurDICMD, ISOShift);
+
 	if(ncfg->Config & NIN_CFG_MEMCARDEMU)
-	{
+		{
 		// Memory card emulation is enabled.
 		// Set up the memory card file.
 		char BasePath[20];
 		snprintf(BasePath, sizeof(BasePath), "%s:/saves", GetRootDevice());
 		f_mkdir_char(BasePath);
-
 		char MemCardName[8];
 		memset(MemCardName, 0, 8);
-		if ( ncfg->Config & NIN_CFG_MC_MULTI )
+		if (( ncfg->Config & NIN_CFG_MC_MULTI ) && (IsTRIGame == 0)) //(TRIGame == TRI_NONE)
 		{
 			// "Multi" mode enabled.
 			// Use one memory card for USA/PAL games,
@@ -660,9 +783,11 @@
 			else
 				memcpy(MemCardName, "ninmem", 6);
 		}
+		else if(IsTRIGame != 0) //if((IsTRIGame(ncfg->GamePath, CurDICMD, ISOShift) != 0))  
+			ncfg->Config &= ~NIN_CFG_MEMCARDEMU;
 		else
 		{
-			// One card per game.
+			// One card per game.		
 			memcpy(MemCardName, &(ncfg->GameID), 4);
 		}
 
@@ -676,7 +801,8 @@
 			if(GenerateMemCard(MemCard) == false)
 			{
 				ClearScreen();
-				ShowMessageScreenAndExit("Failed to create Memory Card File!", 1);
+				PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, 232, "Failed to create Memory Card File!" );
+				ExitToLoader(1);
 			}
 		}
 		else
@@ -685,17 +811,6 @@
 			f_close(&f);
 		}
 	}
-	else
-	{
-		// Using real memory card slots. (Wii only)
-		// Setup real SRAM language.
-		syssram *sram;
-		sram = __SYS_LockSram();
-		sram->lang = ncfg->Language;
-		__SYS_UnlockSram(1); // 1 -> write changes
-		while(!__SYS_SyncSram());
-	}
-
 	#define GCN_IPL_SIZE 2097152
 	#define TRI_IPL_SIZE 1048576
 	void *iplbuf = NULL;
@@ -702,14 +817,8 @@
 	bool useipl = false;
 	bool useipltri = false;
 
-	//Check if game is Triforce game
-	u32 IsTRIGame = 0;
-	if (ncfg->GameID != 0x47545050) //Damn you Knights Of The Temple!
-		IsTRIGame = TRISetupGames(ncfg->GamePath, CurDICMD, ISOShift);
-
 	if(IsTRIGame == 0)
 	{
-		// Attempt to load the GameCube IPL.
 		char iplchar[32];
 		iplchar[0] = 0;
 		switch (ncfg->GameID & 0xFF)
@@ -745,7 +854,6 @@
 	}
 	else
 	{
-		// Attempt to load the Triforce IPL. (segaboot)
 		char iplchar[32];
 		snprintf(iplchar, sizeof(iplchar), "%s:/segaboot.bin", GetRootDevice());
 		FIL f;
@@ -762,8 +870,17 @@
 			f_close(&f);
 		}
 	}
+	if((ncfg->Config & NIN_CFG_AUTO_BOOT) == 0)
+	{	
+	// Load Custom Background
+	GRRLIB_FreeTexture(background);
+	CheckTheme();
+	//GRRLIB_Render();
+	FadeIt();
+	sleep(1);
+	}
 
-	//sync changes
+//sync changes
 	CloseDevices();
 
 	WPAD_Disconnect(0);
@@ -773,6 +890,7 @@
 
 	WUPC_Shutdown();
 	WPAD_Shutdown();
+	
 
 	//before flushing do game specific patches
 	if(ncfg->Config & NIN_CFG_FORCE_PROG &&
@@ -782,34 +900,35 @@
 		gprintf("Disabling Force Progressive for this game\r\n");
 		ncfg->Config &= ~NIN_CFG_FORCE_PROG;
 	}
-
+	
 	//make sure the cfg gets to the kernel
 	DCStoreRange((void*)ncfg, sizeof(NIN_CFG));
-
-//set current time
+	//set current time
 	u32 bias = 0, cur_time = 0;
 	__SYS_GetRTC(&cur_time);
 	if(CONF_GetCounterBias(&bias) >= 0)
 		cur_time += bias;
 	settime(secs_to_ticks(cur_time));
-//hand over approx time passed since 1970
+	//hand over approx time passed since 1970
 	*(vu32*)0xD3003424 = (cur_time+946684800);
 
-//set status for kernel to start running
+	//set status for kernel to start running
 	*(vu32*)0xD3003420 = 0x0DEA;
+    if (which_bg == BG_NONE)
+    {
 	while(1)
 	{
 		DCInvalidateRange( STATUS, 0x20 );
 		if( STATUS_LOADING == 0xdeadbeef )
 			break;
-
+		
 		PrintInfo();
-
+		
 		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*6, "Loading patched kernel... %d", STATUS_LOADING);
 		if(STATUS_LOADING == 0)
 		{
 			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*7, "ES_Init...");
-			// Cleans the -1 when it's past it to avoid confusion if another error happens. e.g. before it showed "81" instead of "8" if the controller was unplugged.
+		// Cleans the -1 when it's past it to avoid confusion if another error happens. e.g. before it showed "81" instead of "8" if the controller was unplugged.
 			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 163, MENU_POS_Y + 20*6, " ");
 		}
 		if((STATUS_LOADING > 0 || abs(STATUS_LOADING) > 1) && STATUS_LOADING < 20)
@@ -827,7 +946,7 @@
 		if(STATUS_LOADING == -3)
 			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*9, "Mounting USB/SD device... Error! %d  Shutting down", STATUS_ERROR);
 		if(STATUS_LOADING == 5) {
-/* 			if (timeout == 0)
+/*			if (timeout == 0)
 				timeout = ticks_to_secs(gettime()) + 20; // Set timer for 20 seconds
 			else if (timeout <= ticks_to_secs(gettime())) {
 				STATUS_ERROR = -7;
@@ -836,7 +955,7 @@
 				//memset( (void*)0x92f00000, 0, 0x100000 );
 				//DCFlushRange( (void*)0x92f00000, 0x100000 );
 				//ExitToLoader(1);
-			}*/
+			}*/		
 			PrintFormat(DEFAULT_SIZE, (STATUS_ERROR == -7) ? MAROON:BLACK, MENU_POS_X, MENU_POS_Y + 20*10, (STATUS_ERROR == -7) ? "Checking FS... Timeout!" : "Checking FS...");
 		}
 		if(abs(STATUS_LOADING) > 5 && abs(STATUS_LOADING) < 20)
